import sys
import os
import sqlite3
from PyQt4 import QtCore, QtGui, uic
import subprocess as sub
   
out = sub.check_output("echo $PALM_BIN", shell=True, stderr=sub.STDOUT)
palm_bin = out.rstrip()

qtCreatorFile = palm_bin + '/palm_gf_files/palm_gf_table.ui'

Ui_MainWindow, QtBaseClass = uic.loadUiType(qtCreatorFile)

class MyApp3(QtGui.QMainWindow, Ui_MainWindow):

    class MyTableWidgetItem(QtGui.QTableWidgetItem):
        def __init__(self, text, sortKey):
            QtGui.QTableWidgetItem.__init__(self, text, QtGui.QTableWidgetItem.UserType)
            self.sortKey = sortKey

        def __lt__(self, other):
            return self.sortKey < other.sortKey


    def __init__(self):   #     def __init__(self, parent=None):
        QtGui.QMainWindow.__init__(self)
        Ui_MainWindow.__init__(self)

        framegm = self.frameGeometry()
        screen = QtGui.QApplication.desktop().screenNumber(QtGui.QApplication.desktop().cursor().pos())
        centerpoint = QtGui.QApplication.desktop().screenGeometry(screen).center()
        framegm.moveCenter(centerpoint)
        self.move(framegm.topLeft())
        self.setupUi(self)
        self.pushButton_3.clicked.connect(self.load_result)
        #self.nx_min.valueChanged.connect(self.check)
        self.load_trigger()
        self.pushButton.clicked.connect(self.filter_results)
        self.Sortnow_button.clicked.connect(self.sort_order)
        self.pushButton_2.clicked.connect(self.load_trigger)



    def load_trigger(self):
        dtb = str('.palm_gf_data.db')
        con = sqlite3.connect(dtb)
        c = con.cursor()
        c.execute("SELECT * FROM " + 'grid_limits')
        mini = c.fetchone()
        max = c.fetchone()
        self.nx_min.setValue(mini[0])
        self.nx_max.setValue(max[0])
        self.ny_min.setValue(mini[1])
        self.ny_max.setValue(max[1])
        self.nz_min.setValue(mini[2])
        self.nz_max.setValue(max[2])
        self.npex_min.setValue(mini[3])
        self.npex_max.setValue(max[3])
        self.npey_min.setValue(mini[4])
        self.npey_max.setValue(max[4])
        self.npxnpy_min.setValue(mini[5])
        self.npxnpy_max.setValue(max[5])
        self.np_min.setValue(mini[6])
        self.np_max.setValue(max[6])
        self.ngpts_min.setValue(mini[7])
        self.ngpts_max.setValue(max[7])

        self.nx_min.setMinimum(mini[0])
        self.nx_max.setMaximum(max[0])
        self.ny_min.setMinimum(mini[1])
        self.ny_max.setMaximum(max[1])
        self.nz_min.setMinimum(mini[2])
        self.nz_max.setMaximum(max[2])
        self.npex_min.setMinimum(mini[3])
        self.npex_max.setMaximum(max[3])
        self.npey_min.setMinimum(mini[4])
        self.npey_max.setMaximum(max[4])
        self.npxnpy_min.setMinimum(mini[5])
        self.npxnpy_max.setMaximum(max[5])
        self.np_min.setMinimum(mini[6])
        self.np_max.setMaximum(max[6])
        self.ngpts_min.setMinimum(mini[7])
        self.ngpts_max.setMaximum(max[7])
        self.ngpts_min.setMaximum(max[7])
        self.ngpts_max.setMinimum(mini[7])



        con.commit()
        c.close()
        con.close()




    def check(self):
        dtb = str('.palm_gf_data.db')
        con = sqlite3.connect(dtb)
        c = con.cursor()
        c.execute("SELECT * FROM " + 'grid_limits')
        mini = c.fetchone()
        max = c.fetchone()
        if self.nx_min.value() < mini[0]:

            self.nx_min.setValue(mini[0])


    def process1(self):
        self.calc_label.setText('loading...')
        QtGui.QApplication.processEvents()



    def load_result(self):
        self.setEnabled(False)
        QtGui.QApplication.processEvents()
        self.load_trigger()
        self.process1()
        database = str('.palm_gf_data.db')
        conn = sqlite3.connect(database)
        c = conn.cursor()
        c.execute("SELECT * FROM " + 'grid_current')
        results = c.fetchall()

        self.tableWidget.setRowCount(len(results))

        i = 0
        j = 0
        k = 0

        while i < len(results):
            line = results[i]
            while j < 8:
                var = line[j]

                self.tableWidget.setItem(i, j, self.MyTableWidgetItem(str(var), j+i))
                #item = self.MyTableWidgetItem(str(var), k)
                #self.tableWidget.setItem(i, j, item)

                j += 1
                #if j == 3:
                    #print(k)
                #k += 1
            #k -= 7
            k += 1
            j = 0
            i += 1

        c.close()
        conn.close()
        self.calc_label.setText('loading completed')
        self.label_11.setText(str(len(results)) + ' results ')
        self.setEnabled(True)
        QtGui.QApplication.processEvents()

    def filter_results(self):
        self.setEnabled(False)
        self.calc_label.setText('calculating...')
        QtGui.QApplication.processEvents()
        database = str('.palm_gf_data.db')
        conn = sqlite3.connect(database)
        c = conn.cursor()
        c.execute("SELECT * FROM " + "grid_current")
        results = c.fetchall()
        #print(results)

        self.tableWidget.setRowCount(len(results))

        i = 0
        j = 0
        row_cnt = -1
        while i < len(results):
            line = results[i]

            if line[0] <= self.nx_max.value():

                if line[0] >= self.nx_min.value():

                    if line[1] <= self.ny_max.value():

                        if line[1] >= self.ny_min.value():

                            if line[2] <= self.nz_max.value():

                                if line[2] >= self.nz_min.value():

                                    if line[3] <= self.npex_max.value():

                                        if line[3] >= self.npex_min.value():

                                            if line[4] <= self.npey_max.value():

                                                if line[4] >= self.npey_min.value():

                                                    if line[5] <= self.npxnpy_max.value():

                                                        if line[5] >= self.npxnpy_min.value():

                                                            if line[6] <= self.np_max.value():

                                                                if line[6] >= self.np_min.value():

                                                                    if line[7] <= self.ngpts_max.value():

                                                                        if line[7] >= self.ngpts_min.value():

                                                                            row_cnt += 1
                                                                            while j < 8:
                                                                                var = line[j]
                                                                                self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(str(var), i))

                                                                                j += 1

            j = 0
            i += 1

        c.close()
        conn.close()
        self.tableWidget.setRowCount(row_cnt + 1)
        self.setEnabled(True)
        self.calc_label.setText('calculation completed')
        self.label_11.setText(str(row_cnt + 1) + ' results')
        QtGui.QApplication.processEvents()





    def sort_order(self):

        sorted = 0
        fnx_mn = self.nx_min.value()
        fnx_mx = self.nx_max.value()
        fny_mn = self.ny_min.value()
        fny_mx = self.ny_max.value()
        fnz_mn = self.nz_min.value()
        fnz_mx = self.nz_max.value()
        fnpex_mn = self.npex_min.value()
        fnpex_mx = self.npex_max.value()
        fnpey_mn = self.npex_min.value()
        fnpey_mx = self.npey_max.value()
        fnpxnpy_mn = self.npxnpy_min.value()
        fnpxnpy_mx = self.npxnpy_max.value()
        fnp_mn = self.np_min.value()
        fnp_mx = self.np_max.value()
        fngpts_mn = self.ngpts_min.value()
        fngpts_mx = self.ngpts_max.value()

        if str(self.Sortvariable_box.currentIndex()) == str(1):


            sorted_col = "nx"
        if str(self.Sortvariable_box.currentIndex()) == str(2):

            sorted_col = "ny"
        if str(self.Sortvariable_box.currentIndex()) == str(3):

            sorted_col = "nz"
        if str(self.Sortvariable_box.currentIndex()) == str(4):

            sorted_col = "npex"
        if str(self.Sortvariable_box.currentIndex()) == str(5):

            sorted_col = "npey"
        if str(self.Sortvariable_box.currentIndex()) == str(6):

            sorted_col = "npxnpy"
        if str(self.Sortvariable_box.currentIndex()) == str(7):

            sorted_col = "np"
        if str(self.Sortvariable_box.currentIndex()) == str(8):

            sorted_col = "ngpts"

        print(self.Sortvariable_box.currentIndex())

        if str(self.Sortorder_box.currentIndex()) == str(1):

            order = " ASC"

        if str(self.Sortorder_box.currentIndex()) == str(2):

            order = " DESC"








        conn = sqlite3.connect(".palm_gf_data.db")
        c = conn.cursor()
        c.execute("SELECT * FROM grid_current  WHERE nx <= " + str(fnx_mx) + " AND nx >= "  + str(fnx_mn) + " AND ny <= " + str(fny_mx) + " AND ny >= " + str(fny_mn) + " AND nz <= " + str(fnz_mx) +
                  " AND nz >= " + str(fnz_mn) + " AND npex <= " + str(fnpex_mx) + " AND npex >= " +
        str(fnpex_mn) + " AND npey <= " + str(fnpey_mx) + " AND npey >= " + str(fnpey_mn) + " AND "
                  "npxnpy <= " + str(fnpxnpy_mx) + " AND npxnpy >= " + str(fnpxnpy_mn) + " AND np <= " + str(fnp_mx) + " AND np >= " + str(fnp_mn) + " AND ngpts <= " + str(fngpts_mx) + " AND ngpts >= " + str(fngpts_mn) +
        " ORDER BY " + str(sorted_col) + str(order))



        sorted = c.fetchall()

        c.close()
        conn.close()
        self.tableWidget.setRowCount(len(sorted))

        for row_indx in range(0,len(sorted)):

            for col_indx in range(0,8):
                row = sorted[row_indx]
                value = row[col_indx]
                self.tableWidget.setItem(row_indx, col_indx, QtGui.QTableWidgetItem(str(value)))






        print(len(sorted))
        #print(sorted)




if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    window = MyApp3()
    window.setWindowTitle('Gridfilter')
    window.show()
    sys.exit(app.exec_())

